<script lang="ts" setup>
import { computed, onBeforeUnmount, onMounted, ref, useAttrs } from 'vue';
import { ScrollToTopButtonProps } from './types';
const props = withDefaults(defineProps<ScrollToTopButtonProps>(), {
  anchor: 'body',
  iconColor: 'white',
  backgroundColor: '#2C3436',
  showButtonTreshold: 1,
  withAnimation: true,
  size: 'medium',
  position: 'bottom-right',
  noTeleport: false,
  marginFromSide: '12px'
})

defineOptions({
  inheritAttrs: false
})

const attrs = useAttrs()

const handleScrollToTop = () => {
  window.scrollTo({
    top: 0,
    behavior: 'smooth'
  })
}

const scrollPos = ref(0)
const handleScroll = () => {
  scrollPos.value = window.scrollY
}

const shouldShowButton = computed(() => scrollPos.value >= props.showButtonTreshold)
const resolvedSize = computed(() => ({
  'small': '36px',
  'medium': '48px',
  'large': '60px'
}[props.size]))

const resolvedPosition = computed(() => ({
  'top-left': {
    'top': props.marginFromSide,
    'right': 'auto',
    'bottom': 'auto',
    'left': props.marginFromSide,
  },
  'top': {
    'top': props.marginFromSide,
    'right': 'auto',
    'bottom': 'auto',
    'left': `calc(50vw - ${resolvedSize.value})`,
  },
  'top-right': {
    'top': props.marginFromSide,
    'right': props.marginFromSide,
    'bottom': 'auto',
    'left': 'auto',
  },
  'right': {
    'top': `calc(50vh - ${resolvedSize.value})`,
    'right': props.marginFromSide,
    'bottom': 'auto',
    'left': 'auto',
  },
  'bottom-right': {
    'top': 'auto',
    'right': props.marginFromSide,
    'bottom': props.marginFromSide,
    'left': 'auto',
  },
  'bottom': {
    'top': 'auto',
    'right': 'auto',
    'bottom': props.marginFromSide,
    'left': `calc(50vw - ${resolvedSize.value})`,
  },
  'bottom-left': {
    'top': 'auto',
    'right': 'auto',
    'bottom': props.marginFromSide,
    'left': props.marginFromSide,
  },
  'left': {
    'top': `calc(50vh - ${resolvedSize.value})`,
    'right': 'auto',
    'bottom': 'auto',
    'left': props.marginFromSide,
  },
}[props.position]))


onMounted(() => {
  handleScroll()
  window.addEventListener('scroll', handleScroll);
})

onBeforeUnmount(() => {
  window.removeEventListener('scroll', handleScroll);
})

</script>

<template>
  <Teleport :to="anchor" :disabled="noTeleport">
    <Transition :name="withAnimation ? 'appear' : 'scrollToTopButton'" appear>
      <button v-show="shouldShowButton" v-bind="attrs" :class="['scrollToTopButton', attrs.class]"
        @click="handleScrollToTop" aria-label="Scroll to Top" role="button">
        <span class="visually-hidden">Scroll to Top</span>
        <slot name="icon">
          <svg viewBox="0 0 24 24" width="24px" height="24px" xmlns="http://www.w3.org/2000/svg">
            <path d="M12 8l-8 8h16z" />
          </svg>
        </slot>
      </button>
    </Transition>
  </Teleport>
</template>

<style>
.scrollToTopButton {
  background-color: v-bind(backgroundColor);
  position: fixed;
  top: v-bind(resolvedPosition.top);
  right: v-bind(resolvedPosition.right);
  bottom: v-bind(resolvedPosition.bottom);
  left: v-bind(resolvedPosition.left);
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 100%;
  min-height: v-bind(resolvedSize);
  aspect-ratio: 1;
  border: none;
  filter: drop-shadow(0px 4px 4px rgba(0, 0, 0, 0.2));
  transition: all ease .2s;
  cursor: pointer;
}

.scrollToTopButton:hover {
  transform: translateY(-2px);
}

.scrollToTopButton:active {
  transform: translateY(2px);
}

.scrollToTopButton>svg {
  fill: v-bind(iconColor)
}

.appear-enter-active,
.appear-leave-active {
  scale: 1;
  opacity: 1;
  transition: scale 0.3s ease, opacity 0.3s ease;
}

.appear-enter-from,
.appear-leave-to {
  scale: 0.1;
  opacity: 0.5
}

.visually-hidden {
  position: absolute;
  width: 1px;
  height: 1px;
  margin: -1px;
  padding: 0;
  overflow: hidden;
  clip: rect(0, 0, 0, 0);
  border: 0;
}
</style>
